#define _WINSOCKAPI_
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "PopRetDlg.h"
#include "PopPassDlg.h"
#include "fileman.h"
#include "global.h"
#include "PrintDlg.h"
//#include "PopMainWin.h"
//---------------------------------------------------------------------------
#pragma link "Pop3Prot"
#pragma resource "*.dfm"
TPopRetrDlg *PopRetrDlg;
//---------------------------------------------------------------------------
// timeout capability is in progress
// search on CurTime and Timer2 and TimeOut for view of current
//---------------------------------------------------------------------------
void __fastcall PopRetrieveMail(TStringList *Accounts, TForm *Owner, TForm *MainForm,
   bool GetUndeleted)
{
   PopRetrDlg = new TPopRetrDlg(Owner);
   CenterDialog(PopRetrDlg,Owner);
   PopRetrDlg->accts->Text = Accounts->Text;
   PopRetrDlg->MainForm = MainForm;
   PopRetrDlg->getALL = GetUndeleted;
   PopRetrDlg->ShowModal();
   delete PopRetrDlg;
}
//---------------------------------------------------------------------------
__fastcall TPopRetrDlg::TPopRetrDlg(TComponent* Owner)
  : TForm(Owner)
{
   Display->Clear();
   accts = new TStringList();
   acct = new TStringList();
   uidl = new TStringList();
   msg = new TStringList();
   lastretrieved = 0;
   totalmails = 0;
   index = -1;
// initialize timeout for TIMEOUT in process under construction
   TimeOut = GetAppIni(Pop3TimeOut,"").ToIntDef(360);
}
//---------------------------------------------------------------------------
__fastcall TPopRetrDlg::~TPopRetrDlg()
{
   delete msg;
   delete uidl;
   delete acct;
   delete accts;
}
//---------------------------------------------------------------------------
void __fastcall TPopRetrDlg::LoadAcct(int Index)
{
   if (Index<0 || Index>accts->Count-1) return;
   acct->Clear();
   AnsiString item,s = accts->Strings[Index];
   int i=0; while ((item=GetParam(i++,s,"\255"))!="")
      acct->Add(item);
}
//---------------------------------------------------------------------------
bool __fastcall TPopRetrDlg::Remember()
{
   return acct->Values["remember"]=="1";
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPopRetrDlg::UserId()
{
   return GetParam(0,acct->Values["account"],"@");
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPopRetrDlg::Account()
{
   return acct->Values["account"];
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPopRetrDlg::PopHost()
{
   AnsiString host = GetParam(1,acct->Values["account"],"@");
   return GetParam(0,host,":");
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPopRetrDlg::Password()
{
   return acct->Values["password"];
}
//---------------------------------------------------------------------------
bool __fastcall TPopRetrDlg::PgpOnly()
{
   return acct->Values["pgponly"]=="1";
}
//---------------------------------------------------------------------------
bool __fastcall TPopRetrDlg::Delete()
{
   return acct->Values["delete"]=="1";
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPopRetrDlg::Port()
{
   AnsiString port,acc = GetParam(1,acct->Values["account"]);
   port = GetParam(1,acc,":");
   return port.IsEmpty() ? AnsiString("pop3") : port;
}
//---------------------------------------------------------------------------
void __fastcall TPopRetrDlg::DISPLAY(AnsiString &msg)
{
   bool locked=LockWindowUpdate(Handle);
   Display->Lines->Add(msg);
   if (locked) LockWindowUpdate(0);
}
//---------------------------------------------------------------------------
void __fastcall TPopRetrDlg::FormShow(TObject *Sender)
{
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TPopRetrDlg::Timer1Timer(TObject *Sender)
{
   index++; Timer1->Enabled = false;
   if (index>=accts->Count)
   {
      Finished = true;
      if (totalmails)
      {
         MyBeep(MB_OK);
         MainForm->Perform(WM_OPENINBOX,0,NULL);
         Hide(); Application->ProcessMessages();//Sleep(300);
         DISPLAY(AnsiString(totalmails)+" messages retrieved");
         ModalResult = mrOk;
         return;
      }
      else
      {
         MyBeep(MB_ICONHAND);
         DISPLAY("No mail");
      }
      StopBtn->Caption = "Ok";
      return;
   }
   GetMailThisAccount(index);
}
//---------------------------------------------------------------------------
void __fastcall TPopRetrDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   MainForm->Perform(WM_STOREPOPLOG,totalmails,(LPARAM)Display->Lines->Text.c_str());
}
//---------------------------------------------------------------------------
// We should start a TTimer to handle timeout...
void __fastcall TPopRetrDlg::GetMailThisAccount(int Index)
{
   LoadAcct(Index);
   AnsiString password;
   if (Display->Lines->Count) DISPLAY("");
   DISPLAY("Connecting to "+PopHost()+"...");
   if (!Remember()) password = GetPopPassword(this,UserId()+"@"+PopHost(),Cancel);
   if (Cancel)
   {
      DISPLAY("Operation cancelled!");
      return;
   }
   // set TimeOut
   // TIMEOUT under construction
   CurTime = 0; Timer2->Enabled = true;

   POP3->UserName = UserId();
   POP3->Host = PopHost();
   POP3->Port = Port();
   POP3->PassWord = password.IsEmpty() ? Password() : password;
   POP3->Connect();
}
//---------------------------------------------------------------------------
void __fastcall TPopRetrDlg::POP3Display(TObject *Sender, AnsiString Msg)
{
   DISPLAY(Msg);
}
//---------------------------------------------------------------------------
void __fastcall TPopRetrDlg::POP3RequestDone(TObject *Sender,
  TPop3Request RqType, WORD Error)
{
   if (Cancel) return;
   if (Error)
   {
      DISPLAY("Error ("+AnsiString((int)Error)+") "+POP3->ErrorMessage);
      StopBtn->Caption = "Ok";
      return;
   }
   static bool statnomail=false;
   AnsiString fname,lr=POP3->LastResponse;
   switch (RqType)
   {
      case pop3Connect:
         DISPLAY("Logging in to POP Server");
         POP3->User();
         break;
      case pop3User:
         DISPLAY(" USER "+lr);
         POP3->Pass();
         break;
      case pop3Pass:
         DISPLAY(" PASS "+lr);
         if (PgpOnly()) DISPLAY(" RETR Retrieving only PGP mail");
         POP3->Stat();
         break;
      case pop3Stat:
         DISPLAY(" STAT "+lr);
         POP3->MsgNum = 0;
         if (GetParam(1,lr," ")=="0")
         {
            statnomail = true;
            POP3->Noop();
            break;
         }
         POP3->Uidl();
         break;
      case pop3Uidl:
         POP3->MsgNum = getALL ? 0:lastretrieved;
         DISPLAY(" UIDL +OK "+lr);
         DISPLAY(" LAST +OK "+AnsiString(lastretrieved));
      case pop3Noop:
         if (POP3->MsgNum >= POP3->MsgCount)
         {
            POP3->Quit();
            break;
         }
         POP3->MsgNum++;
         POP3->List();
         break;
      case pop3List:
         DISPLAY(" LIST "+lr);
         POP3->MsgNum = GetParam(1,lr," ").ToIntDef(0);
         BytesTotal = GetParam(2,lr," ").ToIntDef(0);
         if (PgpOnly())
         {
            DISPLAY(" RETR "+AnsiString((int)POP3->MsgNum)+"...");
            POP3->MsgLines = 1;
            POP3->Top();
            break;
         }
         totalmails++;
         DISPLAY(" RETR Retreiving Message "+AnsiString((int)POP3->MsgNum));
         POP3->Retr();
         break;
      case pop3Retr:
         MainForm->Perform(WM_INCOMINGMAIL,0,(LPARAM)msg->Text.c_str());
         msg->Clear();
         //DISPLAY(" RETR +OK "+AnsiString((int)POP3->MsgNum));
         if (Delete())
         {
            POP3->Dele();
            break;
         }
         POP3->Noop();
         break;
      case pop3Dele:
         DISPLAY(" DELE "+lr.SubString(5,32));
         POP3->Noop();
         break;
      case pop3Top:
         if (msg->Count)
         {
            int lastline = Display->Lines->Count-1;
            if (msg->Strings[msg->Count-1].Pos("-----BEGIN PGP"))
            {
               Display->Lines->Strings[lastline] = " RETR "+AnsiString((int)POP3->MsgNum)+" yes";
               Application->ProcessMessages(); //Sleep(500);
               Display->Lines->Strings[lastline] = " RETR "+AnsiString((int)POP3->MsgNum)+" Retrieving PGP message";
               //DISPLAY(" RETR "+AnsiString((int)POP3->MsgNum)+" Retrieving PGP message");
               totalmails++;
               POP3->Retr();
               break;
            }
            Display->Lines->Strings[lastline] = " RETR "+AnsiString((int)POP3->MsgNum)+" no";
            //DISPLAY(" RETR "+AnsiString((int)POP3->MsgNum)+" no");
         }
         //DISPLAY(" TOP  Not a PGP message");
         POP3->Noop();
         break;
      case pop3Quit:
//       sm(GetParam(1,uidl->Strings[lastretrieved]," "));
         if (!statnomail && CurTime<TimeOut)
            PutLastMessageId(Account(),GetParam(1,uidl->Strings[lastretrieved]," "));
         DISPLAY("Connection closed!");
         Timer1->Enabled = true;
         break;
   }
}
//---------------------------------------------------------------------------
void __fastcall TPopRetrDlg::POP3MessageBegin(TObject *Sender)
{
   msg->Clear();
   ProgressBar->Min = 0;
   ProgressBar->Max = 100;
   ProgressBar->Position = 0;
   ProgressBar->Visible = true;
}
//---------------------------------------------------------------------------
void __fastcall TPopRetrDlg::POP3MessageLine(TObject *Sender)
{
   msg->Add(POP3->LastResponse);
   if (BytesTotal!=0)
      ProgressBar->Position = (msg->Text.Length()/BytesTotal)*100;
}
//---------------------------------------------------------------------------
void __fastcall TPopRetrDlg::POP3MessageEnd(TObject *Sender)
{
   lastretrieved = POP3->MsgNum;
   //Sleep(50);
   ProgressBar->Position = 0;
}
//---------------------------------------------------------------------------
void __fastcall TPopRetrDlg::FormResize(TObject *Sender)
{
   StopBtn->Left = Width - 113;
   ProgressBar->Width = Width - 144;
   Display->SelStart = 0;
}
//---------------------------------------------------------------------------
void __fastcall TPopRetrDlg::StopBtnClick(TObject *Sender)
{
   if (StopBtn->Caption=="Stop")
   {
      if (!Finished)
      {
         DISPLAY("Operation cancelled!");
         Display->Perform(EM_LINESCROLL,0,(LPARAM)1);
         StopBtn->Caption = "Ok";
         MyBeep(MB_ICONHAND);
         Cancel = true;
      }
   }
   else
      ModalResult = Cancel ? mrCancel:mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TPopRetrDlg::POP3UidlBegin(TObject *Sender)
{
   uidl->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TPopRetrDlg::POP3UidlLine(TObject *Sender)
{
   uidl->Add(POP3->LastResponse);
}
//---------------------------------------------------------------------------
void __fastcall TPopRetrDlg::POP3UidlEnd(TObject *Sender)
{
   lastretrieved = uidl->Count;
   AnsiString msgid = GetLastMessageId(Account());
   // insert the retrieved msgid into list at top so we'll definately get a match
   // working from bottom to top
   if (uidl->Count) uidl->Insert(0,"0 "+msgid); else uidl->Add("0 "+msgid);
   while (GetParam(1,uidl->Strings[lastretrieved]," ")!=msgid)
      lastretrieved--;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TPopRetrDlg::GetLastMessageId(AnsiString &account)
{
   TStringList *ids = new TStringList();
   ids->SetText((char*)MainForm->Perform(WM_DATREQUEST,GetDatData,(long)PopLastMsgId.c_str()));
   AnsiString msgid = ids->Values[Account()];
   delete ids;
   return msgid;
}
//---------------------------------------------------------------------------
void __fastcall TPopRetrDlg::PutLastMessageId(AnsiString &account, AnsiString &msgid)
{
   TStringList *ids = new TStringList();
   ids->SetText((char*)MainForm->Perform(WM_DATREQUEST,GetDatData,(long)PopLastMsgId.c_str()));
   ids->Values[Account()] = msgid;
   ids->Insert(0,PopLastMsgId); // pass PutAppData path with stringlist of data
   MainForm->Perform(WM_DATREQUEST,PutDatData,(long)ids->Text.c_str());
   delete ids;
}
//---------------------------------------------------------------------------

void __fastcall TPopRetrDlg::PopCopyItemClick(TObject *Sender)
{
   Display->CopyToClipboard();
}
//---------------------------------------------------------------------------
void __fastcall TPopRetrDlg::PopPrintItemClick(TObject *Sender)
{
   if (MsgBoxHwnd(Handle,"Sent this transcript to the printer?","Confirm",MB_OKCANCEL)==IDOK)
     PrintMessage(Display->Lines,Display->Font,"QuickSilver POP3 Transcript",this);
}
//---------------------------------------------------------------------------
void __fastcall TPopRetrDlg::PopupMenu1Popup(TObject *Sender)
{
   PopCopyItem->Enabled = Display->SelLength>0;
}
//---------------------------------------------------------------------------
void __fastcall TPopRetrDlg::POP3SessionConnected(TObject *Sender, WORD Error)
{
   // TIMEOUT under construction
   Timer2->Enabled = false;
   CurTime = 0;
}
//---------------------------------------------------------------------------
void __fastcall TPopRetrDlg::Timer2Timer(TObject *Sender)
{
   // this function is the TIMEOUT (underconstruction) trap
   CurTime++;
   if (CurTime>=TimeOut)
   {
      Cancel = true;
      AnsiString timeoutmsg;
      Timer2->Enabled = false;
      AppProcessMessages(); Sleep(300);
      int reply;
      if (index<accts->Count-1)
      {
         timeoutmsg =
            s("Sorry! The connection timed out. Maybe the server is\n")+
            s("down. Would you like to try again before continuing");
         reply = MsgBoxHwnd(Handle,timeoutmsg,"Connection Timed Out",MB_YESNOCANCEL);
      }
      else
      {
         timeoutmsg =
            s("Sorry! The connection timed out. Maybe the server is\n")+
            s("down. Would you like to try again before quitting?");
         reply = MsgBoxHwnd(Handle,timeoutmsg,"Connection Timed Out",MB_YESNO);
      }
      // I believe this switch is set correctly
      // needs testing...
      // need to make sure the cancel is done correctly
      switch (reply)
      {
         case IDCANCEL: StopBtn->Click(); break;
         case IDYES: index--; // fall through
         case IDNO :
            if (index>=accts->Count-1) StopBtn->Click();
            else
            {
               Cancel = false;
               Timer1Timer(NULL);
            }
            break;
      }
   }
}
//---------------------------------------------------------------------------
