//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "ProThrd.h"
//---------------------------------------------------------------------------
//   Important: Methods and properties of objects in VCL can only be
//   used in a method called using Synchronize, for example:
//
//      Synchronize(UpdateCaption);
//
//   where UpdateCaption could look like:
//
//      void __fastcall TProgressThread::UpdateCaption()
//      {
//        Form1->Caption = "Updated in a thread";
//      }
//---------------------------------------------------------------------------
void __fastcall RunProgressBar(TProgressBar* Bar)
{
   TProgressThread *tp = new TProgressThread(true);
   //tp->FreeOnTerminate = true;
   tp->ProgressBar = Bar;
   tp->Resume();
   delete tp;
}
//---------------------------------------------------------------------------
__fastcall TProgressThread::TProgressThread(bool CreateSuspended)
  : TThread(CreateSuspended)
{
}
//---------------------------------------------------------------------------
void __fastcall TProgressThread::Execute()
{
   Synchronize(SetProgress());
}
//---------------------------------------------------------------------------
TThreadMethod __fastcall TProgressThread::SetProgress()
{
   while (!Terminated && ProgressBar->Position<100)
   {
      ProgressBar->Position++;
      Sleep(100);
   }
   return 0;
}
//---------------------------------------------------------------------------
