//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "qspgpver.h"
#include "pgprecips.h"
#include "PgpPassEx.h"
#include "pgpfiles.h"
#include "global.h"
#include "fileman.h"
#include "headman.h"
#include "pgpdlg.h"
#include "MixmastDlg.h"
#include "pgpdb.h"
#include "pgp.h"
#include "view.h"

// REMEMBER: ActMainForm is the actual QS main form and must be used
// as, ActMainForm->Handle, in all MsgBoxes

USERES("QSPGP.res");
USEUNIT("QSpgpVer.cpp");
USEFORM("PgpRecips.cpp", PgpRecipForm);
USEFORM("Wiper.cpp", WipeForm);
USEUNIT("pgp.cpp");
USEUNIT("Global.cpp");
USEUNIT("Mixmaster.cpp");
USEUNIT("Console.cpp");
USEUNIT("Fmxutils.cpp");
USEFORM("PGPpassEx.cpp", PgpPassForm);
USEUNIT("FileMan.cpp");
USEUNIT("HeadMan.cpp");
USEFORM("MixmastDlg.cpp", MixForm);
USEFORM("PgpDlg.cpp", PgpForm);
USEUNIT("PgpFiles.cpp");
USELIB("zlib.LIB");
USEUNIT("pgpdb.cpp");
USEFORM("View.cpp", ViewDialog);
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) void __fastcall PgpInit(HINSTANCE HMixLib,
   HINSTANCE HSSLLib, TForm *MainForm, HWND AppHandle);
extern "C" __declspec(dllexport) char* __fastcall PgpSignMessage(char *Message);
extern "C" __declspec(dllexport) char* __fastcall PgpEncryptMessage(char *Message);
extern "C" __declspec(dllexport) char* __fastcall PgpEncryptSignMessage(char *Message);
extern "C" __declspec(dllexport) char* __fastcall PgpDecryptVerifyMessage(char *Message);
extern "C" __declspec(dllexport) bool  __fastcall PgpIsConventional(char *Message);
extern "C" __declspec(dllexport) char* __fastcall PgpGetUserIdsKeyIds(char* KeyFile);
// gets individually armored keys
extern "C" __declspec(dllexport) char* __fastcall PgpArmorBlockToArmorKeys(char *keys);
extern "C" __declspec(dllexport) char* __fastcall PgpArmorKeysToArmorBlock(char *keys);
// import/replace pgp keys
extern "C" __declspec(dllexport) bool  __fastcall PgpImportKeysReplace(char *importfile,
   char *pubring, char *secring, bool deleteimportfile);
extern "C" __declspec(dllexport) bool  __fastcall PgpImportKeysAddNew(char *importfile,
   char *pubring, char *secring, bool deleteimportfile);
// init routines
extern "C" __declspec(dllexport) char* __fastcall GetPgpLibVersion();
extern "C" __declspec(dllexport) char* __fastcall GetPgpLibName();
// utility
bool __fastcall CutMessageAtCutmarks(TStrings *msg);
// string for returning char*s
char *retbuf=NULL;
//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
  return 1;
}
//---------------------------------------------------------------------------
void  __fastcall PgpInit(HINSTANCE HMixLib, HINSTANCE HSSLLib, TForm *MainForm,
   HWND AppHandle)
{
   hMixLib=HMixLib; hSSLLib=HSSLLib;
   Application->Handle=AppHandle;
   ActMainForm=MainForm;
}
//---------------------------------------------------------------------------
bool __fastcall PgpImportKeysReplace(char *importfile, char *pubring, char *secring,
   bool deleteImportfile)
{
   int bakcopies=STATSBAKCOPIES;
   AnsiString pubringtmp=s(pubring)+".tmp",secringtmp=s(secring)+".tmp";

   TPgpDB *pubdb=new TPgpDB();
   TPgpDB *secdb=new TPgpDB();
   TPgpDB *impdb=new TPgpDB(importfile);
   for (int k=0; k<impdb->keys->Count; k++)
   {
      TPgpDBKey *key = impdb->GetKey(k);
      if (key->Type()==PGP_PUBKEY) pubdb->AddKey(key); else
      if (key->Type()==PGP_SECKEY) secdb->AddKey(key);
   }
   delete impdb;

   if (pubdb->keys->Count || !FileExists(pubring))
      pubdb->SaveToFileBak(pubring,bakcopies,!Armored);
   if (secdb->keys->Count || !FileExists(pubring))
      secdb->SaveToFileBak(secring,bakcopies,!Armored);
   if (deleteImportfile) DeleteFile(importfile);
   delete secdb;
   delete pubdb;
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall PgpImportKeysAddNew(char *importfile, char *pubring, char *secring,
   bool deleteImportfile)
{
   int bakcopies = STATSBAKCOPIES;
   AnsiString pubringtmp=s(pubring)+".tmp",secringtmp=s(secring)+".tmp";

   TPgpDB *pubdb = new TPgpDB(pubring);
   TPgpDB *secdb = new TPgpDB(secring);
   TPgpDB *impdb = new TPgpDB(importfile);
   for (int k=0; k<impdb->keys->Count; k++)
   {
      TPgpDBKey *key = impdb->GetKey(k);
      if (key->Type()==PGP_PUBKEY && pubdb->Find(key)<0) pubdb->AddKey(key); else
      if (key->Type()==PGP_SECKEY && secdb->Find(key)<0) secdb->AddKey(key);
   }
   delete impdb;

   if (pubdb->keys->Count || !FileExists(pubring))
      pubdb->SaveToFileBak(pubring,bakcopies,!Armored);
   if (secdb->keys->Count || !FileExists(pubring))
      secdb->SaveToFileBak(secring,bakcopies,!Armored);
   if (deleteImportfile) DeleteFile(importfile);
   delete secdb;
   delete pubdb;
   return true;
}
//---------------------------------------------------------------------------
char* __fastcall PgpGetUserIdsKeyIds(char *KeyFile)
{
   TPgpDb *pgpdb = new TPgpDb(KeyFile,"");
   if (pgpdb->error!=0)
   {
      delete pgpdb;
      return NULL;
   }

   TStringList *ids = new TStringList();
   TPgpKey *key = pgpdb->FirstKey();
   while (key)
   {
      for (int i=0; i<key->UserIds->Count; i++)
         ids->Add(key->IdText8+"="+key->UserIds->Strings[i]);
      key = key->Next;
   }
   if ((retbuf=new char[ids->Text.Length()+1])!=NULL)
      strcpy(retbuf,ids->Text.c_str());

   delete pgpdb;
   delete ids;
   return retbuf;
}
//---------------------------------------------------------------------------
bool __fastcall InType1(AnsiString &remailer, TStrings *type1)
{
   bool ok = false;
   for (int i=0; i<type1->Count; i++)
   {
      if (type1->Strings[i]==remailer)// || type->Strings[i]=="#"+remailer)
      {
         ok = true;
         break;
      }
   }
   return ok;
}
//---------------------------------------------------------------------------
AnsiString __fastcall GetParamSpc(int pos, AnsiString fromStr)
{
   fromStr = fromStr.Trim();
   int p = fromStr.Pos(" ");
   AnsiString prm=fromStr.Trim().SubString(1,p-1);
   if (pos>0) return GetParamSpc(pos-1,fromStr.SubString(p,256));
   return prm;
}
//---------------------------------------------------------------------------
char* __fastcall PgpArmorKeysToArmorBlock(char *KeyBlocks)
{
   TStringList *keyblocks = new TStringList(); keyblocks->SetText(KeyBlocks);
   if (retbuf) delete retbuf; retbuf = NULL;

   TPgpDB *pgpdb = new TPgpDB(keyblocks);
   delete keyblocks;

   BUFFER *bigblock = buf_new();
   pgpdb->SaveToBuffer(bigblock);
   pgp_armor(bigblock,2);

   if ((retbuf=new char[bigblock->length+1])!=NULL)
      strcpy(retbuf,(char*)bigblock->data);
   buf_free(bigblock);
   return retbuf;
}
//---------------------------------------------------------------------------
char* __fastcall PgpArmorBlockToArmorKeys(char *BigBlock)
{
   TStringList *bigblock = new TStringList(); bigblock->SetText(BigBlock);
   if (retbuf) delete retbuf; retbuf = NULL;

   TPgpDB *pgpdb = new TPgpDB(bigblock);
   delete bigblock;

   TStringList *keyblocks = new TStringList();
   pgpdb->SaveToStrings(keyblocks);

   if ((retbuf=new char[keyblocks->Text.Length()+1])!=NULL)
      strcpy(retbuf,keyblocks->Text.c_str());
   delete keyblocks;

   delete pgpdb;
   return retbuf;
}
//---------------------------------------------------------------------------
char* __fastcall PgpEncryptMessage(char *Message)
{
   AnsiString passphrase;
   TStringList *msg = new TStringList(); msg->SetText(Message);
   if (retbuf) delete retbuf; retbuf = NULL;

   CutMessageAtCutmarks(msg);
   if (!msg->Count)
   {
      MsgBoxHwnd(ActMainForm->Handle,
         s("Your message appears empty! Nothing to sign!"),
        "QS PGP Encrypt Error",
         MB_OK
      );
      delete msg;
      return NULL;
   }
   int idx=0; while (idx<msg->Count && !msg->Strings[idx].Trim().IsEmpty())
       idx++;
   if (idx==msg->Count)// || !msg->Strings[idx].TrimRight().IsEmpty())
   {
      MsgBoxHwnd(ActMainForm->Handle,
         s("Your message does not appear to have a body--or maybe\n")+
         s("there is not an empty line between headers and body\n\n")+
         s("Nothing to encrypt!"),
         "QS Encrypt Error",MB_OK);
      delete msg;
      return NULL;
   }
   // remove headers and hold for later
   TStringList *mail = new TStringList();
   while (msg->Count>idx+1)
   {
      mail->Add(msg->Strings[idx+1]);
      msg->Delete(idx+1);
   }
   if (!mail->Count)
   {
      MsgBoxHwnd(ActMainForm->Handle,
         s("Your message appears empty! Nothing to sign!"),
        "QS Encrypt Error",
         MB_OK
      );
      delete msg;
      return NULL;
   }

   TStringList *recips = new TStringList();
   THeaderManager *Headers = new THeaderManager(msg);
   Headers->GetRecipsFull("To: ",recips,msg);
   delete Headers;
   if (!PGPgetEncryptList(recips))
   {
      delete recips;
      delete msg;
      return NULL;
   }

   bool cEncrypt = recips->Text==UseConventional+"\r\n";
   if (cEncrypt && !PGPgetConventionalPassphrase(passphrase,ActMainForm))
   {
      delete recips;
      delete msg;
      return NULL;
   }

   int result;
   TPgpForm *Pgp = new TPgpForm(PgpPublicRing(),PgpSecretRing(),PgpRemailRing(),ActMainForm);
   if (cEncrypt) result = Pgp->EncryptCMessage(mail,passphrase);
   else result = Pgp->EncryptMessage(mail,recips);
   delete Pgp;

   if (result==PGP_OK)
   {
      msg->AddStrings(mail); mail->Clear();
      if ((retbuf=new char[msg->Text.Length()+1])!=NULL)
         strcpy(retbuf,msg->Text.c_str());
   }

   delete recips;
   delete mail;
   delete msg;
   return retbuf;
}
//---------------------------------------------------------------------------
char* __fastcall PgpEncryptSignMessage(char *Message)
{
   AnsiString passphrase;
   TStringList *msg = new TStringList(); msg->SetText(Message);
   TStringList *recips = new TStringList();
   THeaderManager *Headers = new THeaderManager(msg);
   AnsiString keyid=Headers->GetDat("From: ");
   Headers->GetRecipsFull("To: ",recips,msg);
   delete Headers;
   if (retbuf) delete retbuf; retbuf = NULL;

   // get list of public keys
   if (!PGPgetEncryptList(recips,NotConventional))
   {
      delete recips;
      delete msg;
      return NULL;
   }
   // open keyrings for signing key
   TPgpDb *pgpdb = new TPgpDb(PgpPublicRing(),PgpSecretRing());
   if (pgpdb->error!=0)
   {
      delete pgpdb;
      delete recips;
      delete msg;
      return NULL;
   }
   TStringList *keys = new TStringList();
   TPgpKey *Key = pgpdb->FirstKey();
   while (Key)
   {
      if (Key->IsPair)
      {
         TPgpKey *skey = Key->SecKey;
         if (skey->UserIds->Count)
         {
            for (int i=0; i<skey->UserIds->Count; i++)
               keys->Add(skey->UserIds->Strings[i]);
         }
      }
      Key = Key->Next;
   }
   delete pgpdb;
   // fail job if no secret keys
   if (!keys->Count)
   {
      MsgBox("No keys found!","QS PGP Error",MB_OK);
      delete recips;
      delete keys;
      delete msg;
      return NULL;
   }

   // pause
   Application->ProcessMessages(); Sleep(200);
   // keys ok, get sign key and passphrase
   int current=keys->IndexOf(keyid);
   int clearsign = GetAppIni(ClearSignMessage,"").ToIntDef(0);
   if (!PGPgetKeyidAndPassphrase(keys,current,passphrase,clearsign,ActMainForm))
   {
      delete recips;
      delete keys;
      delete msg;
      return NULL;
   }
   if (current>=0 && current<keys->Count)
      keyid = keys->Strings[current];
   // ok we have the key, parse it
   int first=keyid.Pos("<")+1,last=keyid.Pos(">")-1;
   keyid = keyid.SubString(first,last?last-(first-1):keyid.Length());
   // prepare message
   CutMessageAtCutmarks(msg);
   if (!msg->Count)
   {
      MsgBoxHwnd(ActMainForm->Handle,
         s("Your message appears empty! Nothing to sign!"),
        "QS PGP Encrypt Error",
         MB_OK
      );
      ClearString(passphrase);
      delete recips;
      delete keys;
      delete msg;
      return NULL;
   }
   int idx=0; while (idx<msg->Count && !msg->Strings[idx].TrimRight().IsEmpty())
       idx++;
   if (idx==msg->Count)
   {
      MsgBoxHwnd(ActMainForm->Handle,
         s("Your message does not appear to have a body--or maybe\n")+
         s("there is not an empty line between headers and body\n\n")+
         s("Nothing to encrypt!"),
         "QS PGP Encrypt Error",MB_OK);
      ClearString(passphrase);
      delete recips;
      delete keys;
      delete msg;
      return NULL;
   }
   TStringList *mail = new TStringList();
   while (msg->Count>idx+1)
   {
      mail->Add(msg->Strings[idx+1]);
      msg->Delete(idx+1);
   }
   if (!mail->Count)
   {
      MsgBoxHwnd(ActMainForm->Handle,
         s("Your message appears empty! Nothing to sign!"),
        "QS PGP Encrypt Error",
         MB_OK
      );
      ClearString(passphrase);
      delete recips;
      delete keys;
      delete msg;
      return NULL;
   }
   int result;
   TPgpForm *Pgp = new TPgpForm(PgpPublicRing(),PgpSecretRing(),PgpRemailRing(),ActMainForm);
   result = Pgp->EncryptSignMessage(mail,keyid,passphrase,recips,clearsign);
   delete Pgp;

   if (result==PGP_OK)
   {
      msg->AddStrings(mail); mail->Clear();
      if ((retbuf=new char[msg->Text.Length()+1])!=NULL)
         strcpy(retbuf,msg->Text.c_str());
      PutAppIni(ClearSignMessage,clearsign?"1":"0");
   }
   delete mail;
   delete keys;
   delete recips;
   delete msg;
   return retbuf;
}
//---------------------------------------------------------------------------
char* __fastcall PgpSignMessage(char *Message)
{
   TStringList *msg = new TStringList(); msg->SetText(Message);
   if (retbuf) delete retbuf; retbuf = NULL;

   CutMessageAtCutmarks(msg);
   if (!msg->Count)
   {
      MsgBoxHwnd(ActMainForm->Handle,
         s("Your message appears empty! Nothing to sign!"),
        "QS PGP Encrypt Error",
         MB_OK
      );
      delete msg;
      return NULL;
   }
   int idx=0; while (idx<msg->Count && !msg->Strings[idx].Trim().IsEmpty())
       idx++;
   if (idx==msg->Count)
   {
      MsgBoxHwnd(ActMainForm->Handle,
         s("Your message does not appear to have a body--or maybe\n")+
         s("there is not an empty line between headers and body\n\n")+
         s("Nothing to sign!"),
        "QS PGP Encrypt Error",
         MB_OK
      );
      delete msg;
      return NULL;
   }

   TPgpDb *pgpdb = new TPgpDb(PgpPublicRing(),PgpSecretRing());
   if (pgpdb->error!=0)
   {
      delete pgpdb;
      delete msg;
      return NULL;
   }

   TStringList *keys = new TStringList();
   TPgpKey *Key = pgpdb->FirstKey();
   while (Key)
   {
      if (Key->IsPair)
      {
         TPgpKey *skey = Key->SecKey;
         if (skey->UserIds->Count)
         {
            for (int i=0; i<skey->UserIds->Count; i++)
               keys->Add(skey->UserIds->Strings[i]);
         }
      }
      Key = Key->Next;
   }
   delete pgpdb;

   if (!keys->Count)
   {
      MsgBox("No keys found!","QS PGP Error",MB_OK);
      delete keys;
      delete msg;
      return NULL;
   }

   THeaderManager *Headers = new THeaderManager(msg);
   AnsiString keyid=Headers->GetDat("From: ");
   TStringList *recips = new TStringList();
   Headers->GetRecipsFull("To: ",recips);
   delete Headers;

   AnsiString passphrase;
   int current=keys->IndexOf(keyid);
   if (!PGPgetKeyidAndPassphrase(keys,current,passphrase,2,ActMainForm))
   {
      delete recips;
      delete keys;
      delete msg;
      return NULL;
   }

   if (current>=0 && current<keys->Count)
      keyid = keys->Strings[current];
   // ok we have the key, parse it
   int first=keyid.Pos("<")+1,last=keyid.Pos(">")-1;
   keyid = keyid.SubString(first,last>=0?last-(first-1):keyid.Length());

   // there is no need to transfer body to separate list as
   // the pgp sign cleartext takes the whole message--headers and body
   int result;
   TPgpForm *Pgp = new TPgpForm(PgpPublicRing(),PgpSecretRing(),PgpRemailRing(),ActMainForm);
   Pgp->ToRemailer = Pgp->IsRemailed(recips); // to test for remailer address
   result = Pgp->SignMessage(msg,keyid,passphrase);
   delete Pgp;

   if (result==PGP_OK && (retbuf=new char[msg->Text.Length()+1])!=NULL)
      strcpy(retbuf,msg->Text.c_str());

   delete recips;
   delete keys;
   delete msg;
   return retbuf;
}
//---------------------------------------------------------------------------
bool __fastcall PgpIsConventional(char *Message)
{
   TPgpMsg *pgpmsg = new TPgpMsg(Message);
   bool is = pgpmsg->IsConventional();
   delete pgpmsg;
   return is;
}
//---------------------------------------------------------------------------
bool __fastcall GoodKeys(TStrings *keylist)
{
   bool good = false;
   for (int i=0; i<keylist->Count; i++)
      if (keylist->Strings[i].Pos("0x")>1)
      {
         good = true;
         break;
      }
   return good;
}
//---------------------------------------------------------------------------
char* __fastcall PgpDecryptVerifyMessage(char *Message)
{
   TPgpDBKey *key;
   TPgpMsg *msg = new TPgpMsg(Message);
   if (msg->IsConventional())
   {
      delete msg;
      return IsConventionalEncr.c_str();
   }
   // get key for keyid of encrypt msg
   AnsiString userid;
   TStringList *id8=new TStringList();
   TStringList *tmp=new TStringList();
   tmp->Text = msg->IdText8();
   for (int i=0; i<tmp->Count; i++)
      if (id8->IndexOf(tmp->Strings[i])<0)
         id8->Add(tmp->Strings[i]);
   delete tmp;

   TStringList *uids = new TStringList();
   TPgpDB *pgpdb = new TPgpDB(PgpSecretRing());
   for (int i=0; i<pgpdb->KeyCount(); i++)
   {
//sm(id8->Text);
      key = pgpdb->GetKey(i);
      if (id8->IndexOf(key->IdText8())>=0)
         uids->Add(key->KeyUserIds(0)+" 0x"+key->IdText8());
   }
   for (int i=0; i<id8->Count; i++)
      if (!uids->Text.Pos("0x"+id8->Strings[i]))
         uids->Add("0x"+id8->Strings[i]);
//sm(uids->Text);
   if (!GoodKeys(uids))
   {
      for (int i=0; i<id8->Count; i++) id8->Strings[i] = "0x"+id8->Strings[i];
      MsgBoxHwnd(ActMainForm->Handle,
         s("Sorry, you do not have a secret key corresponding to any\n")+//required to\n")+
         s("of the public keys below.\n\n"+id8->Text),
         "Can't Decrypt",
         MB_OK
      );
      delete pgpdb;
      delete id8;
      delete msg;
      return NULL;
   }
   delete pgpdb;
   AnsiString passphrase;
   if (!PGPgetSecretKeyPassphrase(uids->Text,passphrase,ActMainForm))
   {
      delete uids;
      delete id8;
      delete msg;
      return NULL;
   }

   delete uids;
   int result=16; // just a non-error number
   if (msg->buf->length)
   {
      TPgpForm *Pgp = new TPgpForm(PgpPublicRing(),PgpSecretRing(),PgpRemailRing(),ActMainForm);
      result = Pgp->DecryptMessage(msg->buf,passphrase);
      delete Pgp;
   }
   else
      MsgBoxHwnd(ActMainForm->Handle,"Nothing to decrypt!","PGP Decrypt Error",MB_OK);

   if (result==PGP_OK || result==PGP_SIGOK || result==PGP_SIGBAD || result==PGP_SIGNKEY)
   {
      if ((retbuf=new char[msg->buf->length+1])!=NULL)
         strcpy(retbuf,(char*)msg->buf->data);
   }
   delete msg;
   return retbuf;
}
//---------------------------------------------------------------------------
char* __fastcall GetPgpLibName()
{
   return AppName.c_str();
}
//---------------------------------------------------------------------------
char* __fastcall GetPgpLibVersion()
{
   return ReleaseVer.c_str();
}
//---------------------------------------------------------------------------
bool __fastcall CutMessageAtCutmarks(TStrings *msg)
{
   bool cut = false;
   if (msg->Text.Pos("\r\n"+CutMarks+"\r\n"))
   {
      while (msg->Count)
      {
         AnsiString line = msg->Strings[msg->Count-1];
         msg->Delete(msg->Count-1);
         if (line.TrimRight()==CutMarks) break;
      }
      cut = true;
   }
   while (msg->Count && msg->Strings[msg->Count-1].IsEmpty())
      msg->Delete(msg->Count-1);
   return cut;
}
//---------------------------------------------------------------------------












